#!/bin/sh
echo -ne "Content-type:text/plain\r\n"
echo -ne "\r\n" # end of HTTP header 


if [ $REQUEST_METHOD = POST ]; then
	strparam=`cat $stdin | cut -c1-$CONTENT_LENGTH`
else
	strparam=$QUERY_STRING
fi

GET_NTP_PATH="/mnt/flash2/unifs/usr/bin/GetNTPServer"
REGISTER_PATH="/mnt/flash2/unifs/usr/bin/RegisterDevice"
GET_SSH_PATH="/mnt/flash2/unifs/usr/bin/GetSSHServer"
CONNECT_PATH="/mnt/flash2/unifs/usr/bin/ConnectSSH"
GET_CONNECT_PATH="/mnt/flash2/unifs/usr/bin/GetConnectInfo"
ACTIVE_STATUS_PATH="/mnt/flash2/unifs/etc/conf.d/ActiveStatus"

retry_time=0
logger -t "[Stratocast]" "Activating: Get NTP server"
$GET_NTP_PATH >> /dev/null
result=$?
while [ "$result" != "0" ]
do
	
	if [ "$retry_time" == "5" ]; then
		echo -ne "Error occurs when getting NTP server"	
		# status page
	fi

	retry_time=$(($retry_time+1))
	logger -t "[Stratocast]" "Activating: Get NTP server failed ($retry_time)"
	
	sleep 30	
	$GET_NTP_PATH >> /dev/null
	result=$?	
done
logger -t "[Stratocast]" "Activating: Get NTP successfully"

retry_time=0
logger -t "[Stratocast]" "Activating: Registering"
$REGISTER_PATH $strparam >> /dev/null
result=$?
while [ "$result" != "0" ]
do
	if [ "$result" == "1" ]; then
		#401
		echo -ne "Invalid Device Authentication Code or the Camera is Already Registered"
		logger -t "[Stratocast]" "Invalid Device Authentication Code or the camera is already registered"
		exit 1
		# status page
	fi
	
	if [ "$result" == "3" ]; then
		#403
		echo -ne "Device is not allowed into the system"
		logger -t "[Stratocast]" "Device is not allowed into the system"
		exit 1
	fi

	if [ "$result" == "4" ]; then
		#404
		echo -ne "Register is called before \"Generate Activation Code\""
		logger -t "[Stratocast]" "Register is called before \"Generate Activation Code\""
		exit 1
	fi
	
	if [ "$retry_time" == "5" ]; then
		echo -ne "Error occurs when activating"
		logger -t "[Stratocast]" "Activating: Error occurs when activating"
		# status page
	fi

	retry_time=$(($retry_time+1))
	logger -t "[Stratocast]" "Activating: Registering failed ($retry_time)"
	
	sleep 30
	$REGISTER_PATH $strparam >> /dev/null
	result=$?
done
logger -t "[Stratocast]" "Activating: Registering successfully"

retry_time=0
logger -t "[Stratocast]" "Activating: Get SSH information"
$GET_SSH_PATH >> /dev/null
result=$?
while [ "$result" != "0" ]
do
	if [ "$retry_time" == "5" ]; then
		echo -ne "Error occurs when getting SSH server"
		logger -t "[Stratocast]" "Error occurs when getting SSH server"
		# status page	
	fi
	
	retry_time=$(($retry_time+1))
	
	$GET_CONNECT_PATH >> /dev/null
	if [ "$?" == "4" ]; then
		echo -ne "The camera is already unregistered"
		logger -t "[Stratocast]" "The camera is already unregistered"
		exit 1
	fi
	logger -t "[Stratocast]" "Activating: Get SSH information failed ($retry_time)"
	sleep 30
	$GET_SSH_PATH >> /dev/null
	result=$?
done

$CONNECT_PATH >> /dev/null

#echo -ne "#!/bin/sh\n" > $ACTIVE_STATUS_PATH
#echo -ne "ACTIVE_STATUS=1\n" >> $ACTIVE_STATUS_PATH

echo -ne "Activated"
